Attribute VB_Name = "modUtil"
Option Explicit

Declare Function SetLocalTime Lib "Coredll" (ByVal lpSystemTime As String) As Long
Declare Function GetLocalTime Lib "Coredll" (ByVal lpSystemTime As String) As Long
Declare Function GetLastError Lib "Coredll" () As Long
Public Declare Function CompareString Lib "Coredll" Alias "CompareStringW" (ByVal Locale As Long, ByVal dwCmpFlags As Long, ByVal lpString1 As String, ByVal cchCount1 As Long, ByVal lpString2 As String, ByVal cchCount2 As Long) As Long
Public Declare Function CopyFile Lib "Coredll" Alias "CopyFileW" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, ByVal bFailIfExists As Long) As Long
Declare Function CreateProcess Lib "Coredll" Alias "CreateProcessW" (ByVal lpImageName As String, _
                        ByVal lpCmdLine As String, _
                        ByVal psaProcess As Long, _
                        ByVal psaThread As Long, _
                        ByVal bInheritSec As Boolean, _
                        ByVal lCreate As Long, _
                        ByVal lEnviron As Long, _
                        ByVal lpDirectory As Long, _
                        ByVal psaStartInfo As Long, _
                        ByVal psaProcInfo As Long) As Long
Public Declare Function PlaySound Lib "Coredll" Alias "PlaySoundW" (ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long
Public Declare Function GetTickCount Lib "Coredll" () As Long
Public Declare Sub GwesPowerOffSystem Lib "Coredll" ()
Public Declare Function GetAsyncKeyState Lib "Coredll" (ByVal vKey As Long) As Integer

Declare Function PeekMessage Lib "coredll.dll" Alias "PeekMessageW" _
    (ByVal MSG As String, ByVal hWnd As Long, ByVal wMsgFilterMin As Integer, _
    ByVal wMsgFilterMax As Integer, ByVal wRemoveMsg As Integer) As Boolean
Declare Function TranslateMessage Lib "coredll.dll" (ByVal MSG As String) As Boolean
Declare Function DispatchMessage Lib "coredll.dll" Alias "DispatchMessageW" _
    (ByVal MSG As String) As Boolean

Declare Function RegQueryValueEx Lib "Coredll" Alias "RegQueryValueExW" _
        (ByVal hKey As Long, _
        ByVal lpValueName As String, _
        ByVal lpReserved As Long, _
        lpType As Long, _
        ByVal lpData As String, _
        lpcbData As Long) As Long
Declare Function RegSetValueEx Lib "Coredll" Alias "RegSetValueExW" _
        (ByVal hKey As Long, _
        ByVal lpValueName As String, _
        ByVal Reserved As Long, _
        ByVal dwType As Long, _
        ByVal lpData As String, _
        ByVal cbData As Long) As Long
Declare Function RegCreateKeyEx Lib "Coredll" Alias "RegCreateKeyExW" _
        (ByVal hKey As Long, _
        ByVal lpSubKey As String, _
        ByVal Reserved As Long, _
        ByVal lpClass As String, _
        ByVal dwOptions As Long, _
        ByVal samDesired As Long, _
        lpSecurityAttributes As Long, _
        phkResult As Long, _
        lpdwDisposition As Long) As Long
Declare Function RegOpenKeyEx Lib "Coredll" Alias "RegOpenKeyExW" _
        (ByVal hKey As Long, _
        ByVal lpSubKey As String, _
        ByVal ulOptions As Long, _
        ByVal samDesired As Long, _
        phkResult As Long) As Long
Declare Function RegCloseKey Lib "Coredll" (ByVal hKey As Long) As Long

Public Const HKEY_CURRENT_USER = &H80000001
Public Const REG_SZ = 1                 ' Unicode null terminated string
Public Const PM_REMOVE = 1
Public Const SND_FILENAME = &H20000     ' name is a file name
Public Const NORM_IGNORECASE = &H1      ' ignore case
Public Const NORM_IGNORESYMBOLS = &H4   ' ignore symbols
Const CSTR_LESS_THAN = 1                ' string 1 less than string 2
Const CSTR_EQUAL = 2                    ' string 1 equal to string 2
Const CSTR_GREATER_THAN = 3             ' string 1 greater than string
Public Const CE_INTEGER = 2
Public Const CE_LONG = 4
Public Const VK_LBUTTON = &H1
Public MSG  As String

Public Sub DoEventsCE()
    MSG = String(18, Chr(0))
    ' Get message from queue and dispatch it
    If PeekMessage(MSG, 0, 0, 0, PM_REMOVE) Then
        TranslateMessage (MSG)
        DispatchMessage (MSG)
    End If
End Sub

Private Sub ShutDown()
    If MsgBox("Shutdown device now?", vbYesNo, "Shutdown") = vbNo Then Exit Sub
    
    GwesPowerOffSystem
End Sub

Private Sub TestGetTickCount()
    Dim i As Integer
    Dim j As Integer
    Dim strBuffer As String
    Dim lStart As Long
    Dim lStop As Long
    Dim lElapsed As Long
    Dim lAverage As Long
    
    ' Get the start time
    lStart = GetTickCount()
    For i = 1 To 10 ' Do 10 tests
        For j = 1 To 500
            strBuffer = strBuffer & "A"
        Next j
    Next i
    
    ' Get the stop time
    lStop = GetTickCount()
    
    ' calculate the elapsed time
    lElapsed = lStop - lStart
    
    ' calculate the average
    lAverage = lElapsed / 10
    
    MsgBox "The average execution time was " & lAverage & " ms"
End Sub

Public Sub Beep()
    PlaySound "Exclam", 0, SND_FILENAME
End Sub

Private Sub LaunchCalculator()
    Dim lReturn As Long
    
    ' Launch Calculator
    lReturn = CreateProcess("calc.exe", "", 0, 0, False, 0, 0, 0, 0, 0)
    
    ' Check for success
    If lReturn = 0 Then
        MsgBox "Error launching application!", vbExclamation, "Error"
    End If
End Sub

Private Sub MoveErrLog()
    Dim strSource As String
    Dim strDestination As String
    Dim lReturn As Long
    
    ' Build source and destination strings
    strSource = App.Path & "\ERRLOG.TXT"
    
    strDestination = "\ErrLogs\MyApp" & DatePart("yyyy", Now) _
                                        & DatePart("m", Now) _
                                        & DatePart("d", Now) _
                                        & ".TXT"
    ' copy the file
    lReturn = CopyFile(strSource, strDestination, True)
    
    ' Check for success
    If lReturn = 0 Then
        MsgBox "File Copy Failed!", vbExclamation, "Error"
    End If
End Sub

Private Sub TestCompareString()
    Dim strString1 As String
    Dim strString2 As String
    Dim iCompare As Integer
    
    strString1 = "AppLes?"
    strString2 = "[aPp.lEs]"
    
    ' Compare the strings, ignoring case and symbols
    iCompare = CompareString(0, NORM_IGNORECASE Or NORM_IGNORESYMBOLS, strString1, _
            Len(strString1), strString2, Len(strString2))
    
    ' display test results
    If iCompare = CSTR_EQUAL Then
        MsgBox "They're Equal"
    ElseIf iCompare = CSTR_GREATER_THAN Then
        MsgBox strString1 & " is greater than " & strString2
    Else
        MsgBox strString1 & " is less than " & strString2
    End If
End Sub

Private Sub TestGetByteValue()
    Dim i As Long
    
    ' Get byte values from an Integer
    i = GetByteValue(&H1234, 0)
    i = GetByteValue(&H1234, 1)

    ' Get byte values from a Long
    i = GetByteValue(&H38765432, 0)
    i = GetByteValue(&H38765432, 1)
    i = GetByteValue(&H38765432, 2)
    i = GetByteValue(&H38765432, 3)
End Sub

Private Sub TestBinaryStrings()
    Dim i As Long
    Dim s As String

    ' Transfer an Integer to a binary string and back
    s = ToBinaryString(&H1234, 2)
    i = FromBinaryString(s)
    
    ' Transfer a Long to a binary string and back
    s = ToBinaryString(&H12345678, CE_LONG)
    i = FromBinaryString(s)
    
    ' Transfer a negative number to a binary string and back
    s = ToBinaryString(-56745, CE_LONG)
    i = FromBinaryString(s)
    
End Sub

Public Function FromBinaryString(BString As String) As Variant
    Dim i As Integer
    Dim bIsNegative As Boolean
    
    bIsNegative = False
    
    ' start at the end of the string and work backwards
    For i = LenB(BString) - 1 To 0 Step -1
        If i = LenB(BString) - 1 And (AscB(MidB(BString, i + 1, 2)) And &H80) Then
            ' If it's negative, turn off the most significant bit
            FromBinaryString = FromBinaryString + (AscB(MidB(BString, i + 1, 2)) Xor &H80)
            
            ' Set our flag
            bIsNegative = True
        Else
            FromBinaryString = FromBinaryString + AscB(MidB(BString, i + 1, 2)) * (2 ^ (8 * i))
        End If
    Next i
        
    ' if it is supposed to be negative, make it so
    If bIsNegative Then
        FromBinaryString = FromBinaryString * -1
    End If
    
End Function

Public Function ToBinaryString(Number As Variant, Bytes As Integer) As String
    Dim i As Integer
    Dim bIsNegative As Boolean
    
    ' cannot check byte positions other than 0 to 3
    If Bytes > 4 Or Bytes < 1 Then Exit Function
    
    ' If the number is negative, we need to handle it last, so we'll set a flag
    If Number < 0 Then
        bIsNegative = True
        Number = Number * -1
    Else
        bIsNegative = False
    End If
    
    ' start at the least significant bit (0) and work backwards
    For i = 0 To Bytes - 1
        If i = Bytes - 1 And bIsNegative Then
            ' If the number is negative we must turn on the most significant bit
            ' and then and append it to the string
            ToBinaryString = ToBinaryString & (ChrB(GetByteValue(Number, i) + &H80))
        Else
            ' just append the byte to our string
            ToBinaryString = ToBinaryString & ChrB(GetByteValue(Number, i))
        End If
    Next i
End Function

Public Function GetByteValue(Number As Variant, BytePos As Integer) As Integer
    Dim mask As Long
    
    On Error Resume Next
    
    ' cannot check byte positions other than 0 to 3
    If BytePos > 3 Or BytePos < 0 Then Exit Function
        
    If BytePos < 3 Then
        ' build a mask of all bits on for the desired byte
        mask = &HFF * (2 ^ (8 * BytePos))
    Else
        ' the last bit is reserved for sign (+/-)
        mask = &H7F * (2 ^ (8 * BytePos))
    End If
    
    ' turn of all bits but the byte we're after
    GetByteValue = Number And mask
    
    ' move that byte to the end of the number
    GetByteValue = GetByteValue / (2 ^ (8 * BytePos))
End Function

Public Function SetDeviceTime(Year As Integer, Month As Integer, DayOfWeek As Integer, _
                                Day As Integer, Hour As Integer, Minute As Integer, _
                                Second As Integer, Millisecond As Integer) As Boolean
    
    Dim binaryString As String
    Dim lRet As Long
   
    binaryString = ToBinaryString(Year, CE_INTEGER)
    binaryString = binaryString & ToBinaryString(Month, CE_INTEGER)
    binaryString = binaryString & ToBinaryString(DayOfWeek, CE_INTEGER)
    binaryString = binaryString & ToBinaryString(Day, CE_INTEGER)
    binaryString = binaryString & ToBinaryString(Hour, CE_INTEGER)
    binaryString = binaryString & ToBinaryString(Minute, CE_INTEGER)
    binaryString = binaryString & ToBinaryString(Second, CE_INTEGER)
    binaryString = binaryString & ToBinaryString(Millisecond, CE_INTEGER)
    
    lRet = SetLocalTime(binaryString)
    
    ' check for success
    If lRet = 0 Then
        SetDeviceTime = False
    Else
        SetDeviceTime = True
    End If
End Function

Function GetDeviceTime(ByRef Year As Integer, _
                                ByRef Month As Integer, _
                                ByRef DayOfWeek As Integer, _
                                ByRef Day As Integer, _
                                ByRef Hour As Integer, _
                                ByRef Minute As Integer, _
                                ByRef Second As Integer, _
                                ByRef Millisecond As Integer) As Boolean
    
    Dim binaryString As String
    Dim lRet As Long
    
    ' Allocate space for the variable
    binaryString = String(8, Chr(0))
    
    ' Call the API
    lRet = GetLocalTime(binaryString)
    
    ' Extract the values from the binary string
    ' Remeber, we must use MidB to extract bytes
    Year = FromBinaryString(MidB(binaryString, 1, 2))
    Month = FromBinaryString(MidB(binaryString, 3, 2))
    DayOfWeek = FromBinaryString(MidB(binaryString, 5, 2))
    Day = FromBinaryString(MidB(binaryString, 7, 2))
    Hour = FromBinaryString(MidB(binaryString, 9, 2))
    Minute = FromBinaryString(MidB(binaryString, 11, 2))
    Second = FromBinaryString(MidB(binaryString, 13, 2))
    Millisecond = FromBinaryString(MidB(binaryString, 15, 2))
End Function

Public Function SaveSettingCE(AppName As String, Key As String, Section As String, Setting As String)
    Dim lKey As Long
    Dim lRet As Long
    
    ' Open the key, creating if necessary
    lRet = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\Microsoft\" & AppName & "\" & Key, 0, 0, 0, 0, 0, lKey, 0)
    
    ' Check for success
    If lRet <> 0 Then
        MsgBox "Error opening key", vbExclamation, "Error"
        Exit Function
    End If
    
    ' Set the key value
    ' Value length is bytes, not characters
    lRet = RegSetValueEx(lKey, Section, 0, REG_SZ, Setting, LenB(Setting))
    
    ' Check for success
    If lRet <> 0 Then
        MsgBox "Error saving value", vbExclamation, "Error"
        Exit Function
    End If
    
    ' Close the key
    RegCloseKey lKey
End Function

Public Function GetSettingCE(AppName As String, Key As String, Section As String)
    Dim lKey As Long
    Dim lRet As Long
    Dim strValue As String
    Dim iValueLength As Integer
    Dim lType As Long
    
    ' Allocate space for the value, setting it to zero
    strValue = String(128, Chr(0))
    
    ' Initialize our length variable
    iValueLength = 256
    
    ' Open the key
    lRet = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\Microsoft\" & AppName & "\" & Key, 0, 0, lKey)
    
    ' Check for success
    If lRet <> 0 Then
        MsgBox "Error opening key", vbExclamation, "Error"
        Exit Function
    End If
    
    ' Get the key value
    lRet = RegQueryValueEx(lKey, Section, 0, lType, strValue, iValueLength)
    
    ' Check for success
    If lRet <> 0 Then
        MsgBox "Error getting value", vbExclamation, "Error"
        Exit Function
    End If
    
    ' Close the key
    RegCloseKey lKey
    
    ' Set return value
    ' Value length is bytes, not characters
    GetSettingCE = LeftB(strValue, iValueLength)
End Function
